if Array.length Sys.argv < 2
     then raise ( Invalid_argument "Un u0 est demandé" ) ;;
let u0 = int_of_string Sys.argv.(1) ;;

open Localisation_de_point ;;
open Kholle_localisation_de_point ;;

(* Paramètre : n entier positif *)
(* Génère u_n tel que décrit dans l'énoncé *)
let rec u ( n : int ) : int =
  if n == 0 then u0 else 37698 * ( u ( n - 1) ) mod 524287 ;;

(* Paramètre = n : entier positif *)
(* Génère E_n tel que décrit dans l'énoncé *)
let rec e ( n : int ) : point ensemble =
  let p : point = (0, 0) in
  let ensemble : point ensemble = Array.make n p in
  for i = 0 to n - 1 do
    ensemble.(i) <- ( 2 * ( u ( 2 * i ) ) , 2 * ( u ( 2 * i + 1 ) ) )
  done ;
  ensemble ;;

Printf.printf "Question 1 : a) %i  b) %i  c) %i  \n"
  ( u 100 ) ( u 200 ) ( u 300 ) ;;

let e212 = e 212 ;;
let e512 = e 512 ;;
let e1000 = e 1000 ;;

tri_ensemble e212 ;;
tri_ensemble e512 ;;
tri_ensemble e1000 ;;

let x1, y1 = recherche_e_n e212 121212 in
let x2, y2 = recherche_e_n e512 212121 in
let x3, y3 = recherche_e_n e1000 111222 in
Printf.printf "Question 4 : a) ( %i, %i )  b) ( %i, %i )  c) ( %i, %i )  \n"
  x1 y1 x2 y2 x3 y3 ;;

let part212 = delaunay_triangulation e212 ;;
let part512 = delaunay_triangulation e512 ;;
let part1000 = delaunay_triangulation e1000 ;;

let nb_arete212 = nombre_aretes part212 in
let nb_arete512 = nombre_aretes part512 in
let nb_arete1000 = nombre_aretes part1000 in
Printf.printf "Question 7 : a) %i  b) %i  c) %i  \n"
  nb_arete212 nb_arete512 nb_arete1000 ;;

let zone1 = localisation_de_point ( 212121, 122121 ) ( creation_partition part212 ) in
let zone2 = localisation_de_point ( 221111, 144211 ) ( creation_partition part512 ) in
let zone3 = localisation_de_point ( 111111, 212121 ) ( creation_partition part1000 ) in
Printf.printf "Question 13 : a) %i  b) %i  c) %i \n" zone1 zone2 zone3;;
